(function () {
    'use strict';

    class GameData {
        static InitData(successcallback) {
            var playerData = Laya.LocalStorage.getItem("playerData");
            if (playerData) {
                console.log("============老用户============");
                GameData.playerData = JSON.parse(playerData);
                var day = new Date().getDate();
                if (GameData.playerData.curDay != day) {
                    console.log("============新的一天============");
                    GameData.playerData.curDay = day;
                }
            } else {
                console.log("============新用户============");
            }

            Laya.timer.loop(500, this, GameData.AutoSaveData);

            var config = [
                "res/JSON/car.json",
                "res/JSON/map.json",
                "res/JSON/station.json",
            ];

            Laya.loader.load(config, Laya.Handler.create(this, function () {
                GameData.JSONCar = Laya.loader.getRes(config[0]);
                GameData.JSONMap = Laya.loader.getRes(config[1]);
                GameData.JSONStation = Laya.loader.getRes(config[2]);
                GameData.AutoSaveData();
                successcallback();
            }));
        }

        static SaveData() {
            var playerData = JSON.stringify(GameData.playerData);
            Laya.LocalStorage.setItem("playerData", playerData);
            console.log(playerData);

            GameData.selectCar = GameData.GetUserData("selectCar");
            GameData.money = GameData.GetUserData("money");
        }

        static GetUserData(key) {
            return GameData.playerData[key];
        }

        static SetData(key, value) {
            GameData.playerData[key] = value;
            GameData.AutoSave = true;
        }

        static AutoSaveData() {
            if (GameData.AutoSave) {
                GameData.SaveData();
                GameData.AutoSave = false;
            }
        }
    }
    GameData.AutoSave = true;//自动保存标识
    GameData.playerData = {
        "sound": 1,
        "yssm": 0,              //隐私声明
        "curDay": 0,            //日期
        "money": 1000,          //金币
        "selectCar": 1,
        "map": [1, 1, 1, 1, 1],
    };

    GameData.JSONCar = null;
    GameData.JSONMap = null;
    GameData.JSONStation = null;
    GameData.money = 0;
    GameData.selectCar = 1;

    class GameManager {
        static ChangeMinuteSecondstr(str) {
            if (str !== "0" && str !== "" && str !== null) {
                return ((Math.floor(str / 60)).toString().length < 2 ? "0" + (Math.floor(str / 60)).toString() :
                    (Math.floor(str / 60)).toString()) + ":" + ((str % 60).toString().length < 2 ? "0" + (str % 60).toString() : (str % 60).toString());
            } else {
                return "00:00";
            }
        }

        static PlaySound(name, loop = 1) {
            var sn = "res/sound/" + name + ".ogg";
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playSound(sn, loop);
                if (GameManager.hasPlayedSound.indexOf(sn) == -1) {
                    GameManager.hasPlayedSound.push(sn);
                    Laya.SoundManager.playSound(sn, loop);
                }
            }));
        }

        static StopSound(name) {
            if (name == null) {
                Laya.SoundManager.stopAll();
            }
            else {
                var sn = "res/sound/moto/" + name + ".wav";
                Laya.SoundManager.stopSound(sn);
            }
        }

        static OpenSound() {
            Laya.SoundManager.muted = false;
        }

        static CloseSound() {
            Laya.SoundManager.muted = true;
        }
        static stopStationSound() {
            if (GameManager.stationSoundName == null) {
                return;
            }
            var sn = "res/sound/bus/" + GameManager.stationSoundName + ".wav";
            Laya.SoundManager.stopSound(sn);
            GameManager.stationSoundName = null;
        }
        static playStationSound(name, loop = 1) {
            this.stopStationSound();
            var sn = "res/sound/bus/" + name + ".wav";
            GameManager.stationSoundName = name;
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playSound(sn, loop);
            }));
        }
        static PlayCarSound(name, loop = 1) {
            var sn = "res/sound/moto/" + name + ".wav";
            return Laya.SoundManager.playSound(sn, loop);
        }

        static PlayMusic(name) {
            Laya.SoundManager.stopAll();
            var sn = "res/sound/" + name + ".wav";
            Laya.loader.load(sn, Laya.Handler.create(this, () => {
                Laya.SoundManager.playMusic(sn, 0);
                if (GameManager.hasPlayedSound.indexOf(sn) == -1) {
                    GameManager.hasPlayedSound.push(sn);
                    Laya.SoundManager.playMusic(sn, 0);

                }
                if (GameData.GetUserData("Sound") == 0) {
                    GameManager.CloseSound();
                }
            }));
        }
        static clearData() {
            GameManager.busList = [0, 0, 0, 0, 0, 0, 0, 0];
            GameManager.stationList = [];
            GameManager.childList = [];
            GameManager.stationNum = 0;
            GameManager.stationSoundName = null;
            GameManager.doorFlag = false;
        }

        static Random(min, max) {
            return Math.floor(Math.random() * (max - min)) + min;
        }
    }
    GameManager.hasPlayedSound = [];
    GameManager.ResScene = null;
    GameManager.Scene = null;
    GameManager.Camera = null;
    GameManager.CarCamera = null;

    GameManager.CarModel = null;
    GameManager.MapModel = null;

    GameManager.Car = null;
    GameManager.CarJS = null;

    GameManager.GasStation = null;
    GameManager.GasStationJS = null;

    GameManager.QDAni = null;
    GameManager.ZDAni = null;
    GameManager.stationList = [];
    GameManager.childList = [];

    GameManager.GameScene = null;
    GameManager.MapID = 0;

    GameManager.FB = false;//卡车前后判定
    GameManager.LR = false;//卡车左右判定

    GameManager.LevelName = ["shanghai1", "nanjing2", "guangzhou3", "qingdao4", "beijing5"];//地图的名字
    GameManager.selectLevel = 0;//选择的地图
    GameManager.pause = true;//暂停

    GameManager.AICarNum = 0;//npc数量

    GameManager.timeStr = 120;//时间
    GameManager.isAddOil = false;
    GameManager.isFristOil = true;
    GameManager.busList = [0, 0, 0, 0, 0, 0, 0, 0];//公交车上的乘客

    GameManager.GearSize = [9, 69, 125];
    GameManager.Gear = 0;
    GameManager.GearSpeed = [0, 1, -1];
    GameManager.hsjCamera = null;
    GameManager.stationNum = 0;
    GameManager.stationSoundName = null;
    GameManager.doorFlag = false;

    GameManager.lowsound = null;
    GameManager.midsound = null;
    GameManager.highsound = null;
    GameManager.soundFlag = false;

    class cheScene extends Laya.Scene {

        constructor() {
            super();
        }

        onEnable() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.moneyNum.text = GameData.money;

            this.showTruckUI();

            this.backBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mainScene.scene");
            });

            Laya.timer.loop(1, this, this.update);
        }

        showTruckUI() {
            this.truck_list.hScrollBarSkin = "";
            this.truck_list.renderHandler = new Laya.Handler(this, this.updateTruck);
            this.truck_list.array = [];

            let array = [];
            console.log("truck:", GameData.JSONCar);
            for (var key in GameData.JSONCar) {
                let data = GameData.JSONCar[key];
                let obj = {};
                obj['truckID'] = { text: key };
                obj['name'] = { text: data.name };
                obj['bg'] = { skin: "cheScene/" + data.image };

                obj['accelerateSpeed'] = { width: data.accelerateSpeed * 100 * 5 };
                obj['maxSpeed'] = { width: data.maxSpeed * 3 };
                obj['Maxoil'] = { width: data.Maxoil / 100 * 5 };

                obj['selectBtn'] = { visible: GameData.selectCar != key ? true : false };
                obj['isSelect'] = { visible: GameData.selectCar == key ? true : false };
                array.push(obj);
            }
            this.truck_list.array = array;
        }

        updateTruck(cell) {
            let selectBtn = cell.getChildByName("selectBtn");
            let id = cell.getChildByName("truckID").text;
            selectBtn.offAll();
            selectBtn.on(Laya.Event.CLICK, this, this.selectTruck, [id]);
        }

        selectTruck(id) {
            console.log("============选择第" + id + "个选项============");
            GameData.selectCar = id;
            GameData.SetData("selectCar", GameData.selectCar);
            this.showTruckUI();
        }

        update() {
            this.moneyNum.text = GameData.money;
        }

        onDisable() {
        }
    }

    class TriggerCollisionScript extends Laya.Script3D {
        constructor() {
            super();
            this.controller = null;
        }
        onTriggerEnter(other) {
            let id = this.checkHitObject(other.owner);
            if (id != -1) {
                if (id == 999) {
                    this.controller.playerFlag = true;
                } else {
                    this.controller.stopFlag = true;
                }
            }
        }

        onTriggerStay(other) {
        }

        onTriggerExit(other) {
            let id = this.checkHitObject(other.owner);
            if (id != -1) {
                if (id == 999) {
                    this.controller.playerFlag = false;
                } else {
                    this.controller.stopFlag = false;
                }
                this.controller.onCollision = false;
            }
        }
        onCollisionEnter(collision) {
        }
        onCollisionStay(collision) {
        }
        onCollisionExit(collision) {
        }
        checkHitObject(obj) {
            let name = obj.name;
            if (name.indexOf("car") >= 0) {
                return 999;
            }
            if (name.indexOf("npc_") >= 0) {
                let id = name.substr(name.lastIndexOf("_") + 1);
                if (this.controller.carID == id) {
                    return -1;
                } else {
                    return parseInt(id);
                }
            }
            return -1;
        }
    }

    class AICar extends Laya.Script3D {

        constructor() {
            super();
            this.carID = 1;
            this.onCollision = false;
            this.InitFinish = false;
            this.nextPoint = 1;
            this.onGround = false;
            this.playerFlag = false;
            this.stopFlag = false;
            this.accelerateSpeed = 1;
            this.speed = -0.1;
            this.carRigidbody = null;
        }

        onTriggerEnter(other) {
            if (other.owner.name == "" + this.nextPoint) {
                this.nextPoint++;
                if (this.nextPoint >= this.point.length) {
                    this.nextPoint = 0;
                }
                var targePos = this.point[this.nextPoint].transform.position;
                this.lookAt(new Laya.Vector3(targePos.x, this.owner.transform.position.y, targePos.z));
            } else {
                // console.log(other.owner.name);
                // if (other.owner.name = "cfq") {
                //     this.onCollision = true;
                // }
            }
        }

        onTriggerStay(other) {
        }

        onTriggerExit(other) {

        }

        onCollisionEnter(collision) {
            if (collision.other.owner.name.indexOf("car") != -1) {
                // this.onCollision = true;
            } else {
                if (!this.onGround) {
                    this.onGround = true;
                    if (this.carRigidbody != null) {
                        this.carRigidbody.isKinematic = true;
                    }
                }
            }
        }

        onCollisionStay(collision) {
            if (collision.other.owner.name != "ground") {
                this.onCollision = true;
            }
        }

        onCollisionExit(collision) {
            if (collision.other.owner.name.indexOf("car") != -1) {
                this.onCollision = false;
            }
        }

        onEnable() {
            this.f_l_rote = this.owner.getChildByName("Wheels_FL_LOD1");
            this.f_r_rote = this.owner.getChildByName("Wheels_FR_LOD1");
            this.b_l_rote = this.owner.getChildByName("Wheels_RL_LOD1");
            this.b_r_rote = this.owner.getChildByName("Wheels_RR_LOD1");

            this.carRigidbody = this.owner.getComponent(Laya.Rigidbody3D);
        }

        Init(point, carID) {
            this.point = point;
            this.carID = carID;
            this.InitFinish = true;
            this.owner.name = "npc_" + this.carID;
            // this.carjs = this.owner.getChildByName("Cube").addComponent(TriggerCollisionScript);
            // this.carjs.controller = this;
            console.log("AICar 初始化成功");
        }

        lookAt(targetPos) {
            this.owner.transform.lookAt(targetPos, new Laya.Vector3(0, 1, 0));
        }

        onUpdate() {
            if (this.InitFinish && this.onGround && !this.onCollision) {
                if (!this.playerFlag && !this.stopFlag) {
                    this.owner.transform.translate(new Laya.Vector3(0, 0, this.speed * this.accelerateSpeed));

                    this.f_l_rote.transform.rotate(new Laya.Vector3(this.speed * this.accelerateSpeed, 0, 0));
                    this.f_r_rote.transform.rotate(new Laya.Vector3(this.speed * this.accelerateSpeed, 0, 0));
                    this.b_l_rote.transform.rotate(new Laya.Vector3(this.speed * this.accelerateSpeed, 0, 0));
                    this.b_r_rote.transform.rotate(new Laya.Vector3(this.speed * this.accelerateSpeed, 0, 0));


                    var targePos = this.point[this.nextPoint].transform.position;
                    this.lookAt(new Laya.Vector3(targePos.x, this.owner.transform.position.y, targePos.z));
                }
            }
        }

        onDisable() {
        }
    }

    class Car extends Laya.Script3D {

        constructor() {
            super();
            this.accelerateSpeed = 0.1;                           //加速度
            this.accelerateBackSpeed = 0.05;                      //倒车加速度
            this.speed = 0;                                       //当前速度
            this.maxSpeed = 10;                                   //最大速度
            this.maxBackSpeed = -40;                              //倒车最大速度
            this.Maxoil = 100;                                    //最大油量
            this.oil = 100;                                       //油量
            this.oilSpeed = 0;                                     //油量损耗速率
            this.AccelerateRotate = 0.3;                          //转弯速率
            this.MaxAccelerateRotate = 0.15;                      //高速转弯速率
            this.RotateLimit = 5;                                 //达到高速转弯的速度
            this.rotateAngle = 0;
            this.keyDownList = [];
            this.InitFinish = false;
            this.isHuiTan = false;
            this.music = "";
            this.onGround = false;
            this.gravity = 1;
            this.stationFlag = false;
            this.takeoffFlag = false;
            this.carAnimator = null;
            this.stationID = 0;
            this.dipAngle = 0;
            this.dipLimit = 15;
            this.idleAniFlag = false;
            this.backAniFlag = false;
            this.fowardAniFlag = false;
            this.vol = 0;
            this.carmaxSpeed = 0;
        }

        onTriggerEnter(other) {
            if (other.owner.name == "finish") {
                GameManager.pause = true;
                if (GameManager.GameScene != null) {
                    this.speed = 0;
                    GameManager.GameScene.showSuccessUI();
                }
            } else if (other.owner.name == "station") {
                // if (!GameManager.isAddOil) {
                //     if (GameManager.GameScene != null) {
                //         GameManager.pause = true;
                //         this.speed = 0;
                //         GameManager.GameScene.jiayouTipUI.visible = true;
                //         GameManager.StopSound(this.music);
                //         this.music = "";
                //     }
                // }
            } else {
                // console.log(other.owner.name);
                if (other.owner.name == "lg") {
                    if (GameManager.QDAni != null) {
                        GameManager.QDAni.crossFade("lgAni_up", 0.2);
                    }
                }
                if (other.owner.name == "lg_finish") {
                    if (GameManager.QDAni != null) {
                        GameManager.ZDAni.crossFade("lgAni_up", 0.2);
                    }
                }
            }
        }

        onTriggerStay(other) {
            let id = this.checkParent(other);
            if (id != -1 && this.speed <= 1 && !this.takeoffFlag && GameManager.GameScene.doorFlag) {
                if (id > this.stationID) {
                    this.NPCTakeoff(id);
                    this.takeoffFlag = true;
                    GameManager.doorFlag = true;
                }
            }
        }

        onTriggerExit(other) {
            if (other.owner.name == "lg") {
                if (GameManager.QDAni != null) {
                    GameManager.QDAni.crossFade("lgAni_down", 0.2);
                }
            }
            if (other.owner.name == "lg_finish") {
                if (GameManager.QDAni != null) {
                    GameManager.ZDAni.crossFade("lgAni_down", 0.2);
                }
            }
            let id = this.checkParent(other);
            if (id != -1) {
                this.stationFlag = false;
                if (this.takeoffFlag) {
                    this.takeoffFlag = false;
                } else {
                    // console.log("车辆溜站，没有上下客");
                    // if (id > this.stationID) {
                    //     GameManager.GameScene.showFailUI(1);
                    //     return;
                    // }
                }
                this.checkChild(id);
            }
        }

        onCollisionEnter(collision) {
            if (collision.other.owner.name == "ground") {
                this.onGround = true;
            } else if (collision.other.owner.name == "collider") {
                this.CollisionHuiTan();
            }
        }

        onCollisionStay(collision) {
            if (collision.other.owner.name == "collider") {
                this.CollisionHuiTan();
            }

        }

        onCollisionExit(collision) {
            if (collision.other.owner.name == "ground") {
                this.onGround = false;
                this.gravity = 1;
            } else if (collision.other.owner.name == "collider") {
                this.exitHuiTan();
            }
        }

        onEnable() {
            this.car = this.owner;
            this.qian = this.car.getChildByName("tire_q");
            this.hou = this.car.getChildByName("tire_h");

            this.listenKeyboard();
            Laya.timer.loop(100, this, this.setCarSoundVol);
        }

        Init(carJson) {
            this.accelerateSpeed = carJson.accelerateSpeed;                             //加速度
            this.accelerateBackSpeed = carJson.accelerateBackSpeed;                     //倒车加速度
            this.speed = carJson.speed;                                                 //当前速度
            this.carmaxSpeed = carJson.maxSpeed;                                           //最大速度
            this.maxBackSpeed = carJson.maxBackSpeed;                                   //倒车最大速度
            this.Maxoil = carJson.Maxoil;                                               //最大油量
            this.oil = carJson.oil;                                                     //油量
            this.oilSpeed = carJson.oilSpeed * 0;                                       //油量损耗速率

            this.accelerateSpeed = carJson.accelerateSpeed;
            this.maxSpeed = 2;
            this.oil = carJson.oil;

            this.AccelerateRotate = carJson.AccelerateRotate;
            this.MaxAccelerateRotate = carJson.MaxAccelerateRotate;
            this.RotateLimit = carJson.RotateLimit;
            console.log("初始化汽车完成     ", this.car);




            this.carRigidbody = this.car.getComponent(Laya.Rigidbody3D);
            this.InitFinish = true;
            this.carAnimator = this.owner.getChildAt(0).getChildAt(0).getComponent(Laya.Animator);
            // this.carAnimator.crossFade("Idle-b", 0.2);
        }

        listenKeyboard() {
            console.log("设置键盘监听事件");
            //添加键盘按下事件,一直按着某按键则会不断触发
            Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
            //添加键盘抬起事件
            Laya.stage.on(Laya.Event.KEY_UP, this, this.onKeyUp);
        }

        onKeyDown(e) {
            this.keyDownList[e["keyCode"]] = true;
        }

        onKeyUp(e) {
            delete this.keyDownList[e["keyCode"]];
        }

        Keyboard() {
            if (!this.keyDownList[38] && !this.keyDownList[40] && !this.keyDownList[83] && !this.keyDownList[87] && !GameManager.FB) {
                this.speed -= this.speed * 0.001;
                if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) <= 0) {
                    if (!this.idleAniFlag) {
                        this.carAnimator.crossFade("Idle-b", 0.2);
                        this.backAniFlag = false;
                        this.fowardAniFlag = false;
                    }
                }
                if (GameManager.Gear == 1) {
                    if (this.speed > -0.01) {
                        this.speed = 0;
                    }
                } else {
                    if (this.speed < 0.01) {
                        this.speed = 0;
                    }
                }
                switch (GameManager.GameScene.dangwei.text) {
                    case "2":
                        if (this.speed <= this.carmaxSpeed / 10 * 1 - 0.2) {
                            this.downShift();
                        }
                        break;
                    case "3":
                        if (this.speed <= this.carmaxSpeed / 10 * 2 - 0.2) {
                            this.downShift();
                        }
                        break;
                    case "4":
                        if (this.speed <= this.carmaxSpeed / 10 * 4 - 0.2) {
                            this.downShift();
                        }
                        break;
                    case "5":
                        if (this.speed <= this.carmaxSpeed / 10 * 6 - 0.2) {
                            this.downShift();
                        }
                        break;
                    case "6":
                        if (this.speed <= this.carmaxSpeed / 10 * 8 - 0.2) {
                            this.downShift();
                        }
                        break;
                }
                if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) != 0) {
                    let dangwei = parseInt(GameManager.GameScene.dangwei.text);
                    let name = null;
                    this.vol = this.speed / this.maxSpeed;
                    this.vol = Math.round(this.vol * 10) / 10;
                    if (this.vol < 0.2) {
                        this.vol = 0.2;
                    }
                    if (dangwei <= 2) {
                        name = "1";
                        if (this.music != name) {
                            GameManager.StopSound(this.music);
                            GameManager.midsound = null;
                            GameManager.highsound = null;
                            this.music = name;
                            if (GameManager.lowsound == null) {
                                GameManager.lowsound = GameManager.PlayCarSound(this.music, 0);
                            }
                        }
                    } else if (dangwei <= 4) {
                        name = "3";
                        if (this.music != name) {
                            GameManager.StopSound(this.music);
                            GameManager.lowsound = null;
                            GameManager.highsound = null;
                            this.music = name;
                            if (GameManager.midsound == null) {
                                GameManager.midsound = GameManager.PlayCarSound(this.music, 0);
                            }
                        }
                    } else {
                        name = "4";
                        if (this.music != name) {
                            GameManager.StopSound(this.music);
                            GameManager.lowsound = null;
                            GameManager.midsound = null;
                            this.music = name;
                            if (GameManager.highsound == null) {
                                GameManager.highsound = GameManager.PlayCarSound(this.music, 0);
                            }
                        }
                    }
                } else {
                    if (!GameManager.pause) {
                        if (this.music != "low") {
                            GameManager.StopSound(this.music);
                            this.music = "low";
                            GameManager.PlayCarSound(this.music, 0);
                        }
                    }
                }
            } else {
                if (this.keyDownList[38] || this.keyDownList[87]) {
                    this.forward();
                }
                if (this.keyDownList[83] || this.keyDownList[40]) {
                    this.back();
                }
            }

            if (!this.keyDownList[37] && !this.keyDownList[39] && !this.keyDownList[65] && !this.keyDownList[68] && !GameManager.LR) {
                this.rotateAngle += (0 - this.rotateAngle) * 0.2;
                this.dipAngle += (0 - this.dipAngle) * 0.2;
            } else {
                if (this.keyDownList[65] || this.keyDownList[37]) {
                    this.left();
                }
                if (this.keyDownList[68] || this.keyDownList[39]) {
                    this.right();
                }
            }
        }

        onUpdate() {
            if (this.InitFinish && !GameManager.pause) {
                this.Keyboard();
                if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) < 20) {
                    this.dipLimit = 0;
                } else if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) < 70) {
                    this.dipLimit = 20;
                } else if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) < 120) {
                    this.dipLimit = 35;
                } else {
                    this.dipLimit = 45;
                }
                var f = new Laya.Vector3(0, 0, 0);
                this.car.transform.getForward(f);
                if (this.onGround) {
                    this.linearVelocity = new Laya.Vector3(f.x * this.speed, 0, f.z * this.speed);
                    this.carRigidbody.linearVelocity = this.linearVelocity;
                } else {
                    this.gravity++;
                    this.linearVelocity = new Laya.Vector3(f.x * this.speed, -this.gravity, f.z * this.speed);
                    this.carRigidbody.linearVelocity = this.linearVelocity;
                }

                var a = this.speed * (0 - this.rotateAngle) * 0.005;
                a = this.Clamp(a, -1, 1);
                this.carRigidbody.angularVelocity = new Laya.Vector3(0, a, 0);
                // console.log("this.dipAngle  " + this.dipAngle);
                if (Math.abs(this.dipAngle) < 0.1) {
                    this.dipAngle = 0;
                    this.rotateMoto();
                } else {
                    this.rotateMoto();
                }

            } else if (GameManager.pause) {
                this.speed = 0;
                var f = new Laya.Vector3(0, 0, 0);
                this.maxSpeed = 2;
                GameManager.GameScene.dangwei.text = "1";
                this.car.transform.getForward(f);
                if (this.onGround) {
                    this.linearVelocity = new Laya.Vector3(f.x * this.speed, 0, f.z * this.speed);
                    this.carRigidbody.linearVelocity = this.linearVelocity;
                } else {
                    this.gravity++;
                    this.linearVelocity = new Laya.Vector3(f.x * this.speed, -this.gravity, f.z * this.speed);
                    this.carRigidbody.linearVelocity = this.linearVelocity;
                }
                GameManager.FB = false;
                GameManager.LR = false;
            }

            this.CameraMove();
        }

        OilConsumption() {
            this.oil -= Math.abs(this.speed) * this.oilSpeed;
            if (this.oil < 0) {
                this.oil = 0;
                this.speed = 0;
                GameManager.pause = true;
                if (GameManager.isFristOil) {
                    GameManager.isFristOil = false;
                    GameManager.GameScene.showFristOilUI();
                } else {
                    // GameManager.GameScene.showFailUI();
                }
            } else {
                let dangwei = parseInt(GameManager.GameScene.dangwei.text);
                let name = null;
                this.vol = this.speed / this.maxSpeed;
                this.vol = Math.round(this.vol * 10) / 10;
                if (this.vol < 0.2) {
                    this.vol = 0.2;
                }
                if (dangwei <= 2) {
                    name = "1";
                    if (this.music != name) {
                        GameManager.StopSound(this.music);
                        GameManager.midsound = null;
                        GameManager.highsound = null;
                        this.music = name;
                        if (GameManager.lowsound == null) {
                            GameManager.lowsound = GameManager.PlayCarSound(this.music, 0);
                        }
                    }
                } else if (dangwei <= 4) {
                    name = "3";
                    if (this.music != name) {
                        GameManager.StopSound(this.music);
                        GameManager.lowsound = null;
                        GameManager.highsound = null;
                        this.music = name;
                        if (GameManager.midsound == null) {
                            GameManager.midsound = GameManager.PlayCarSound(this.music, 0);
                        }
                    }
                } else {
                    name = "4";
                    if (this.music != name) {
                        GameManager.StopSound(this.music);
                        GameManager.lowsound = null;
                        GameManager.midsound = null;
                        this.music = name;
                        if (GameManager.highsound == null) {
                            GameManager.highsound = GameManager.PlayCarSound(this.music, 0);
                        }
                    }
                }
            }
        }

        AddOil() {
            this.oil = this.Maxoil;
            GameManager.isAddOil = true;
        }

        CollisionHuiTan() {
            if (this.isHuiTan) {
                return;
            }
            this.isHuiTan = true;
            var forward = new Laya.Vector3(0, 0, 0);
            this.car.transform.getForward(forward);
            var speed = 400 * this.speed;
            this.carRigidbody.applyImpulse(new Laya.Vector3(forward.x * speed, 0, forward.z * speed));
            Laya.timer.frameOnce(30, this, function () {
                this.isHuiTan = false;
            });
            // GameManager.GameScene.dangwei.text = "1";
            // this.speed = 0;
        }
        exitHuiTan() {
            // this.isHuiTan = false;
            // this.maxSpeed = this.carmaxSpeed / 10 * 2;
        }
        CameraMove() {
            var fixedDistance = 5 * (0.1 * GameData.selectCar + 1);
            var targetPos = this.car.transform.position;
            var nowPos = GameManager.Camera.transform.position;
            var dx = targetPos.x - nowPos.x;
            var dz = targetPos.z - nowPos.z;
            var actualDistance = Math.sqrt(dx * dx + dz * dz);
            var xm = targetPos.x - dx * fixedDistance / actualDistance;
            var zm = targetPos.z - dz * fixedDistance / actualDistance;
            GameManager.Camera.transform.position = new Laya.Vector3(xm, this.car.transform.position.y + 4.5, zm);
            GameManager.Camera.transform.position.y = 0;
            GameManager.Camera.transform.lookAt(this.car.transform.position, new Laya.Vector3(0, 1, 0));
            GameManager.Camera.transform.rotate(new Laya.Vector3(-20, 0, 0), true, false);
        }


        forward() {
            if (GameManager.pause) {
                this.speed = 0;
            } else {
                if (GameManager.FB || this.keyDownList[38] || this.keyDownList[40] || this.keyDownList[83] || this.keyDownList[87]) {
                    switch (GameManager.Gear) {
                        case 0:
                            if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) == 0) {
                                this.speed = 0;
                            }
                            break;
                        case 1:
                            this.speed -= this.accelerateSpeed;
                            if (this.speed <= this.maxBackSpeed) {
                                this.speed = this.maxBackSpeed;
                            }
                            if (!this.backAniFlag && this.speed < 0) {
                                this.carAnimator.crossFade("backwards", 0.2);
                                this.backAniFlag = true;
                                this.idleAniFlag = false;
                                this.fowardAniFlag = false;
                            }
                            this.OilConsumption();
                            break;
                        case 2:
                            this.speed += this.accelerateSpeed;
                            if (this.speed >= this.maxSpeed) {
                                this.speed = this.maxSpeed;
                            }
                            if (!this.fowardAniFlag && this.speed >= 0) {
                                this.carAnimator.crossFade("drive-loop", 0.2);
                                this.fowardAniFlag = true;
                                this.idleAniFlag = false;
                                this.backAniFlag = false;
                            }
                            this.OilConsumption();
                            break;
                    }
                }
            }
        }

        back() {
            if (GameManager.pause) {
                this.speed = 0;
            } else {
                if (GameManager.FB || this.keyDownList[38] || this.keyDownList[40] || this.keyDownList[83] || this.keyDownList[87]) {
                    this.speed += this.accelerateSpeed * 3 * GameManager.GearSpeed[GameManager.Gear] * 3;
                    switch (GameManager.Gear) {
                        case 0:
                            if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) == 0) {
                                this.speed = 0;
                            }
                            break;
                        case 1:
                            if (this.speed > 0) {
                                this.speed = 0;
                            }
                            break;
                        case 2:
                            if (this.speed < 0) {
                                this.speed = 0;
                            }
                            break;
                    }
                }
            }
            switch (GameManager.GameScene.dangwei.text) {
                case "2":
                    if (this.speed <= this.carmaxSpeed / 10 * 1 - 0.2) {
                        this.downShift();
                    }
                    break;
                case "3":
                    if (this.speed <= this.carmaxSpeed / 10 * 2 - 0.2) {
                        this.downShift();
                    }
                    break;
                case "4":
                    if (this.speed <= this.carmaxSpeed / 10 * 4 - 0.2) {
                        this.downShift();
                    }
                    break;
                case "5":
                    if (this.speed <= this.carmaxSpeed / 10 * 6 - 0.2) {
                        this.downShift();
                    }
                    break;
                case "6":
                    if (this.speed <= this.carmaxSpeed / 10 * 8 - 0.2) {
                        this.downShift();
                    }
                    break;
            }
            if (parseInt(Math.abs(GameManager.CarJS.speed) * 5) != 0) {
                GameManager.StopSound(this.music);
                // this.music = "shache";
                // GameManager.PlayCarSound(this.music, 1);
            }
        }

        left() {
            if (GameManager.LR || this.keyDownList[37] || this.keyDownList[39] || this.keyDownList[65] || this.keyDownList[68]) {
                if (this.rotateAngle < -1) {
                    this.rotateAngle += (0 - this.rotateAngle) * 0.2;
                    this.dipAngle += (0 - this.dipAngle) * 0.2;
                } else {
                    if (this.speed >= this.RotateLimit) {
                        this.rotateAngle += this.MaxAccelerateRotate;
                        this.dipAngle += 0.6;
                    } else {
                        this.rotateAngle += this.AccelerateRotate;
                        this.dipAngle += 0.9;
                    }
                    if (this.dipAngle >= this.dipLimit) {
                        this.dipAngle = this.dipLimit;
                    }
                    if (this.rotateAngle >= 30) {
                        this.rotateAngle = 30;
                    }
                }
            }
        }

        right() {
            if (GameManager.LR || this.keyDownList[37] || this.keyDownList[39] || this.keyDownList[65] || this.keyDownList[68]) {
                if (this.rotateAngle > 1) {
                    this.rotateAngle += (0 - this.rotateAngle) * 0.2;
                    this.dipAngle += (0 - this.dipAngle) * 0.2;
                } else {
                    if (this.speed >= this.RotateLimit) {
                        this.rotateAngle -= this.MaxAccelerateRotate;
                        this.dipAngle -= 0.6;
                    } else {
                        this.rotateAngle -= this.AccelerateRotate;
                        this.dipAngle -= 0.9;
                    }
                    if (this.dipAngle <= -this.dipLimit) {
                        this.dipAngle = -this.dipLimit;
                    }
                    if (this.rotateAngle <= -30) {
                        this.rotateAngle = -30;
                    }
                }
            }
        }

        Clamp(v, min, max) {
            if (v < min) {
                v = min;
            }
            if (v > max) {
                v = max;
            }
            return v;
        }

        localPosition() {
            return this.car.transform.localPosition;
        }

        onDisable() {

        }
        checkParent(obj) {
            let name = obj.owner._parent.name;
            if (name.indexOf("gjz_sh_") >= 0) {
                var id = name.substr(name.lastIndexOf("_") + 1);
                return parseInt(id);
            }
            return -1;
        }
        takeupNPC(id) {
            let num = GameManager.stationList[id - 1].upNum;
            GameManager.stationNum = num;
            for (var i = 0; i < num; i++) {
                GameManager.childList[i].childStartWalk();
            }
            if (id == 5) {
                Laya.timer.once(2 * 1000, this, function () {
                    Laya.timer.scale = 0.0001;
                    GameManager.GameScene.showSuccessUI();
                });
            }
        }
        NPCTakeoff(key, num = null) {
            if (num == null) {
                num = GameManager.stationList[key - 1].downNum;
            }
            if (num == 0) {
                this.takeupNPC(key);
                return;
            }
            let id = GameManager.Random(0, 7);
            if (GameManager.busList[id] == 1) {
                GameManager.busList[id] = 0;
                GameManager.Scene.getChildByName("Car_Nei").getChildAt(id).active = false;
                num--;
                if (num > 0) {
                    return this.NPCTakeoff(key, num);
                } else {
                    this.takeupNPC(key);
                    return;
                }
            } else {
                return this.NPCTakeoff(key, num);
            }
        }
        showNPC() {
            let id = GameManager.Random(0, 7);
            if (GameManager.busList[id] == 0) {
                GameManager.busList[id] = 1;
                GameManager.Scene.getChildByName("Car_Nei").getChildAt(id).active = true;
                return;
            } else {
                return this.showNPC();
            }
        }
        checkChild(stationID) {
            // for (var key in GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("gjz_sh_" + stationID)._children) {
            //     if (GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("gjz_sh_" + stationID)._children[key].name.lastIndexOf("child") != -1) {
            //         console.log("任务失败，没有把站台上的乘客接走");
            //         GameManager.GameScene.showFailUI(2);
            //         return;
            //     }
            // }
            // this.playLeaveSound(stationID);
            // this.stationID = stationID;
        }
        playArrivalSound(id) {
            let map;
            let name;
            switch (GameManager.LevelName[GameManager.selectLevel]) {
                case "shanghai1":
                    map = "sh";
                    break;
                case "nanjing2":
                    map = "nj";
                    break;
                case "guangzhou3":
                    map = "gz";
                    break;
                case "qingdao4":
                    map = "qd";
                    break;
                case "beijing5":
                    map = "bj";
                    break;
            }
            name = map + "_" + id + "_1";
            GameManager.playStationSound(name);
        }
        playLeaveSound(id) {
            let map;
            let name;
            switch (GameManager.LevelName[GameManager.selectLevel]) {
                case "shanghai1":
                    map = "sh";
                    break;
                case "nanjing2":
                    map = "nj";
                    break;
                case "guangzhou3":
                    map = "gz";
                    break;
                case "qingdao4":
                    map = "qd";
                    break;
                case "beijing5":
                    map = "bj";
                    break;
            }
            name = map + "_" + id + "_2";
            GameManager.playStationSound(name);
            Laya.timer.clear(this, this.playDriveSound);
            Laya.timer.once(8.5 * 1000, this, this.playDriveSound);
        }
        playDriveSound() {
            GameManager.playStationSound("notice_1");
        }
        rotateMoto(radians) {
            radians = -this.dipAngle / 180 * Math.PI;
            var v = new Laya.Vector3(0, 0, 0);
            var v1 = new Laya.Vector3(0, 0, 0);
            this.car.transform.rotation.getYawPitchRoll(v);
            this.car.getChildAt(0).transform.rotation.getYawPitchRoll(v1);
            var q1 = new Laya.Quaternion(0, 0, 0, 1);
            Laya.Quaternion.createFromYawPitchRoll(v.x + Math.PI / 2, v.y + radians, v.z, q1);
            var q = new Laya.Quaternion(0, 0, 0, 1);
            Laya.Quaternion.slerp(this.car.getChildAt(0).transform.rotation, q1, 0.1, q);
            this.car.getChildAt(0).transform.rotation = q;
        }
        upShift() {
            if (GameManager.GameScene.dangwei.text == "6" || this.isHuiTan)
                return;
            let dangwei = parseInt(GameManager.GameScene.dangwei.text);
            dangwei++;
            GameManager.GameScene.dangwei.text = dangwei;
            switch (dangwei) {
                case 2:
                    this.maxSpeed = this.carmaxSpeed / 10 * 2;
                    break;
                case 3:
                    this.maxSpeed = this.carmaxSpeed / 10 * 4;
                    break;
                case 4:
                    this.maxSpeed = this.carmaxSpeed / 10 * 6;
                    break;
                case 5:
                    this.maxSpeed = this.carmaxSpeed / 10 * 8;
                    break;
                case 6:
                    this.maxSpeed = this.carmaxSpeed;
                    break;
            }
        }
        downShift() {
            if (GameManager.GameScene.dangwei.text == "1" || this.isHuiTan)
                return;
            let dangwei = parseInt(GameManager.GameScene.dangwei.text);
            dangwei--;
            GameManager.GameScene.dangwei.text = dangwei;
            switch (dangwei) {
                case 1:
                    this.maxSpeed = this.carmaxSpeed / 10 * 1;
                    break;
                case 2:
                    this.maxSpeed = this.carmaxSpeed / 10 * 2;
                    break;
                case 3:
                    this.maxSpeed = this.carmaxSpeed / 10 * 4;
                    break;
                case 4:
                    this.maxSpeed = this.carmaxSpeed / 10 * 6;
                    break;
                case 5:
                    this.maxSpeed = this.carmaxSpeed / 10 * 8;
                    break;
                    break;
            }
        }
        setCarSoundVol() {
            if (this.vol == 0) {
                return;
            }
            if (GameManager.soundFlag) {
                Laya.timer.once(80, this, function () {
                    GameManager.soundFlag = false;
                });
                return;
            }
            if (this.music == "low") {
                this.vol = 1;
            }
            Laya.SoundManager.setSoundVolume(this.vol);
            GameManager.soundFlag = true;
        }
    }

    class Child extends Laya.Script3D {
        constructor() {
            super();
            this.finishPos;
            this.childPos;
            this.walkFlag = false;
        }
        onEnable() {
            this.model = this.owner;
        }
        Init(stationID, key) {
            this.childAnimation = this.model.getComponent(Laya.Animator);
            this.childAnimation.play("idle");
            // this.finishPos = GameManager.Scene.getChildByName("gjz_sh_" + stationID).getChildByName("sh_" + stationID + "_pos1").transform.position;
            this.finishPos = GameManager.Car.getChildByName("geton").transform.position;
            this.childPos = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("gjz_sh_" + stationID).getChildByName("sh_" + stationID + "_pos" + key).transform.position;
        }
        lookAt(targetPos) {
            this.owner.transform.lookAt(targetPos, new Laya.Vector3(0, 1, 0));
            this.owner.transform.rotate(new Laya.Vector3(0, 180, 0), false, false);
        }
        onUpdate() {
            if (this.walkFlag) {
                this.owner.transform.translate(new Laya.Vector3(0, 0, 0.1));
                var targePos = this.finishPos;
                this.lookAt(new Laya.Vector3(targePos.x, this.owner.transform.position.y, targePos.z));
                var dis = Laya.Vector3.distance(targePos, this.owner.transform.position);
                if (dis < 1) {
                    this.walkFlag = false;
                    this.childStopWalk();
                }
            }
        }
        childStartWalk() {
            Laya.timer.once(GameManager.Random(1, 8) * 100, this, function () {
                var targePos = this.finishPos;
                this.lookAt(new Laya.Vector3(targePos.x, this.owner.transform.position.y, targePos.z));
                this.walkFlag = true;
                this.childAnimation.play("walk");
            });
        }
        childStopWalk() {
            this.walkFlag = false;
            GameManager.childList.shift();
            GameManager.stationNum--;
            if (GameManager.stationNum == 0) {
                GameManager.doorFlag = false;
                GameManager.GameScene.tips_img.skin = "gameScene/tips2.png";
                GameManager.GameScene.tips_img.visible = true;
                GameManager.GameScene.tips_img.alpha = 1;
                Laya.Tween.to(GameManager.GameScene.tips_img, { alpha: 0 }, 2 * 1000, null, Laya.Handler.create(GameManager.GameScene, function () {
                    GameManager.GameScene.tips_img.visible = false;
                    GameManager.GameScene.tips_img.alpha = 1;
                }), 5 * 1000, true, true);
            }
            GameManager.CarJS.showNPC();
            this.owner.destroy();
        }
    }

    class GS extends Laya.Script3D {

        constructor() {
            super();
            this.normalizedTime1 = 0;
            this.lastnormalizedTime1 = -1;

            this.normalizedTime2 = 0;
            this.lastnormalizedTime2 = -1;

            this.normalizedTime3 = 0;
            this.lastnormalizedTime3 = -1;

            this.CameraAni = null;
            this.NpcAni = null;
            this.CarAni = null;

            this.isAddOil = false;
            this.isAddOil1 = false;
            this.isAddOil2 = false;
            this.isAddOil3 = false;
        }

        onEnable() {
            for (var key = 1; key < 6; key++) {
                if (key != GameData.selectCar) {
                    this.owner.getChildByName("car" + key).active = false;
                }
            }
            this.CameraAni = this.owner.getChildByName("Camera").getComponent(Laya.Animator);
            this.NpcAni = this.owner.getChildByName("npc5").getComponent(Laya.Animator);
            this.CarAni = this.owner.getChildByName("car" + GameData.selectCar).getComponent(Laya.Animator);
        }

        addOil() {
            this.isAddOil = true;
        }

        onUpdate() {
            if (this.isAddOil) {
                if (this.CameraAni != null) {
                    this.normalizedTime1 = this.CameraAni.getCurrentAnimatorPlayState().normalizedTime;
                    if (this.lastnormalizedTime1 == this.normalizedTime1) {
                        if (!this.isAddOil1) {
                            this.isAddOil1 = true;
                            console.log("加油站摄像头动画播放完毕");
                        }
                    }
                    this.lastnormalizedTime1 = this.normalizedTime1;
                }

                if (this.NpcAni != null) {
                    this.normalizedTime2 = this.NpcAni.getCurrentAnimatorPlayState().normalizedTime;
                    if (this.lastnormalizedTime2 == this.normalizedTime2) {
                        if (!this.isAddOil2) {
                            this.isAddOil2 = true;
                            console.log("加油站NPC车辆动画播放完毕");
                        }
                    }
                    this.lastnormalizedTime2 = this.normalizedTime2;
                }

                if (this.CarAni != null) {
                    this.normalizedTime3 = this.CarAni.getCurrentAnimatorPlayState().normalizedTime;
                    if (this.lastnormalizedTime3 == this.normalizedTime3) {
                        if (!this.isAddOil3) {
                            this.isAddOil3 = true;
                            console.log("加油站玩家车辆动画播放完毕");
                        }
                    }
                    this.lastnormalizedTime3 = this.normalizedTime3;
                }

                if (this.isAddOil1 && this.isAddOil2 && this.isAddOil3) {
                    this.isAddOil = false;
                    this.isAddOil1 = false;
                    this.isAddOil2 = false;
                    this.isAddOil3 = false;

                    if (GameManager.GameScene != null) {
                        // console.log(GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("point"));
                        GameManager.GameScene.createCar(GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("point").getChildByName("jiayou").transform.position);
                        GameManager.Car.transform.lookAt(GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("point").getChildByName("lookPoint").transform.position, new Laya.Vector3(0, 1, 0));
                        GameManager.GasStation.active = false;
                        GameManager.GameScene.oilAni.visible = false;
                        GameManager.GameScene.controlUI.visible = true;
                        GameManager.pause = false;
                    }
                }
            }
        }


        onDisable() {
        }
    }

    class gameScene extends Laya.Scene {
        constructor() {
            super();
            this.value = 0;
            this.normalizedTime = 0;
            this.lastnormalizedTime = -1;
            this.CameraAni = null;
            this.kaichang = true;
        }

        onEnable() {
            GameManager.Gear = 0;
            GameManager.timeStr = 120;
            Laya.timer.scale = 1;
            // this.timeStr.visible = true;
            // this.missionUI.visible = true;
            this.missionUI2.visible = false;
            this.missionUI3.visible = false;
            this.kaichangAni.visible = true;
            this.doorFlag = false;
            this.kaiguanFlag = false;
            GameManager.isFristOil = true;
            GameManager.pause = true;

            this.kaichangAni.getChildByName(GameManager.LevelName[GameManager.selectLevel]).visible = true;
            GameManager.isAddOil = false;

            GameManager.GameScene = this;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            Laya.timer.loop(1, this, this.update);
            for (var key in GameManager.LevelName) {
                GameManager.ResScene.getChildByName(GameManager.LevelName[key]).active = false;
            }

            console.log("选择的地图：" + GameManager.selectLevel);
            GameManager.ResScene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).active = true;
            GameManager.Scene = Laya.stage.addChildAt(GameManager.ResScene, 0);
            // console.log(GameManager.Scene);
            GameManager.Camera = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("Camera");

            this.CameraAni = GameManager.Scene.getChildByName("kaichang").getComponent(Laya.Animator);
            // this.createCar(GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("point").getChildByName("born").transform.position);

            if (GameData.JSONMap[parseInt(GameManager.selectLevel) + 1]["GS"]) {
                GameManager.GasStation = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("jyz");
                GameManager.GasStation.active = false;
                GameManager.GasStationJS = GameManager.GasStation.addComponent(GS);
            }

            GameManager.Camera.active = false;
            // GameManager.pause = false;
            // GameManager.Scene.getChildByName("kaichang").active = false;
            // GameManager.Camera.active = true;
            // this.controlUI.visible = true;
            // Laya.timer.loop(1000, this, function name(params) {
            //     if (!GameManager.pause) {
            //         GameManager.timeStr++;
            //     }
            // });

            this.ButtonClick();

            this.npcPoint = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("npc")._children;
            this.areaPoint = [];
            this.createMoreAICar(3);

            this.CameraAni = GameManager.Scene.getChildByName("kaichang").getComponent(Laya.Animator);
            GameManager.QDAni = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("cs").getChildByName("lg").getComponent(Laya.Animator);
            GameManager.ZDAni = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("zd").getChildByName("lg_finish").getComponent(Laya.Animator);
        }

        reStart() {
            GameManager.timeStr = 120;
            this.timeStr.visible = true;
            // this.missionUI.visible = true;
            this.missionUI2.visible = false;
            this.missionUI3.visible = false;
            GameManager.isFristOil = true;
            GameManager.Gear = 0;

            if (GameManager.Car != null) {
                GameManager.Car.destroy();
                GameManager.Car = null;
                this.createCar(GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("point").getChildByName("born").transform.position);
            }
        }

        createMoreAICar(num = 1) {
            GameManager.AICarNum = 0;
            for (var key in this.areaPoint) {
                for (var i = 0; i < num; i++) {
                    Laya.timer.once(8000 * i, this, this.createAICar, [key], false);
                }
            }
        }

        createAICar(key) {
            var npcCar = Laya.Sprite3D.instantiate(GameManager.CarModel.getChildByName("npc" + GameManager.Random(1, 6)), GameManager.Scene);
            npcCar.transform.position = this.areaPoint[key][0].transform.position;
            var npcCarJS = npcCar.addComponent(AICar);
            npcCarJS.Init(this.areaPoint[key], GameManager.AICarNum);
            GameManager.AICarNum++;
        }

        createCar(point) {
            GameManager.Car = Laya.Sprite3D.instantiate(GameManager.CarModel.getChildByName("biker" + GameData.selectCar), GameManager.Scene);
            GameManager.Car.transform.position = point;
            GameManager.CarJS = GameManager.Car.addComponent(Car);
            GameManager.CarJS.Init(GameData.JSONCar[GameData.selectCar]);
            GameManager.CarCamera = GameManager.Car.getChildByName("Camera_1");
            GameManager.CarCamera.active = false;
        }

        ButtonClick() {
            this.left.on(Laya.Event.MOUSE_DOWN, this, function () {
                GameManager.LR = true;
                Laya.timer.loop(1, this, this.BtnLeft);
            });
            this.left.on(Laya.Event.MOUSE_UP, this, function () {
                Laya.timer.clear(this, this.BtnLeft);
                GameManager.LR = false;
            });

            this.right.on(Laya.Event.MOUSE_DOWN, this, function () {
                GameManager.LR = true;
                Laya.timer.loop(1, this, this.BtnRight);
            });
            this.right.on(Laya.Event.MOUSE_UP, this, function () {
                Laya.timer.clear(this, this.BtnRight);
                GameManager.LR = false;
            });

            this.forward.on(Laya.Event.MOUSE_DOWN, this, function () {
                GameManager.FB = true;
                Laya.timer.loop(1, this, this.BtnForward);
            });
            this.forward.on(Laya.Event.MOUSE_UP, this, function () {
                Laya.timer.clear(this, this.BtnForward);
                GameManager.FB = false;
            });

            this.back.on(Laya.Event.MOUSE_DOWN, this, function () {
                GameManager.FB = true;
                Laya.timer.loop(1, this, this.BtnBack);
            });
            this.back.on(Laya.Event.MOUSE_UP, this, function () {
                Laya.timer.clear(this, this.BtnBack);
                GameManager.FB = false;
            });

            this.pauseBtn.on(Laya.Event.CLICK, this, function () {
                this.pauseUI.visible = true;
                GameManager.pause = true;
                if (GameManager.CarJS != null) {
                    GameManager.StopSound(GameManager.CarJS.music);
                    GameManager.CarJS.music = "";
                }
            });
            this.closePauseBtn.on(Laya.Event.CLICK, this, function () {
                this.pauseUI.visible = false;
                GameManager.pause = false;
            });
            this.reStartBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mapScene.scene", true, true);
            });
            this.mainBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mainScene.scene");
            });
            this.continueBtn.on(Laya.Event.CLICK, this, function () {
                this.pauseUI.visible = false;
                GameManager.pause = false;
            });
            this.changeCamera.on(Laya.Event.CLICK, this, function () {
                if (GameManager.CarCamera != null) {
                    if (GameManager.CarCamera.active) {
                        GameManager.CarCamera.active = false;
                        GameManager.Camera.active = true;
                    } else {
                        GameManager.CarCamera.active = true;
                        GameManager.Camera.active = false;
                    }
                }
            });

            this.sureBtn.on(Laya.Event.CLICK, this, function () {
                if (GameManager.GasStationJS != null) {
                    this.controlUI.visible = false;
                    this.jiayouTipUI.visible = false;
                    this.oilAni.visible = true;
                    GameData.money = GameData.money - 100;
                    GameData.SetData("money", GameData.money);

                    if (GameManager.Car != null) {
                        GameManager.Car.destroy();
                        GameManager.Car = null;
                    }
                    GameManager.GasStation.active = true;
                    GameManager.GasStationJS.addOil();
                    if (GameManager.CarJS != null) {
                        GameManager.CarJS.AddOil();
                    }
                }
            });
            this.cancelBtn.on(Laya.Event.CLICK, this, function () {
                this.jiayouTipUI.visible = false;
                GameManager.pause = false;
            });

            this.nextBtn.on(Laya.Event.CLICK, this, function () {
                GameManager.selectLevel++;
                if (GameManager.selectLevel >= 5) {
                    GameManager.selectLevel = 4;
                    Laya.Scene.open("mapScene.scene", true, false);
                } else {
                    Laya.Scene.open("mapScene.scene", true, true);
                }
            });

            this.againBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mapScene.scene", true, true);
            });

            this.mainBtn1.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mainScene.scene");
            });

            this.reStartBtn1.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mapScene.scene", true, true);
            });

            this.loudspeaker.on(Laya.Event.CLICK, this, function () {
                GameManager.PlaySound("laba");
            });

            this.P.on(Laya.Event.CLICK, this, function () {
                if (GameManager.Gear == 1) {
                    // GameManager.StopSound("daoche");
                }
                GameManager.Gear = 0;
            });

            this.R.on(Laya.Event.CLICK, this, function () {
                // GameManager.PlaySound("daoche", 0);
                GameManager.Gear = 1;
            });

            this.D.on(Laya.Event.CLICK, this, function () {
                if (GameManager.Gear == 1) {
                    // GameManager.StopSound("daoche");
                }
                GameManager.Gear = 2;
            });


            this.sureBtn1.on(Laya.Event.CLICK, this, function () {
                this.fristOil.visible = false;
                if (GameManager.CarJS != null) {
                    GameManager.CarJS.oil = GameManager.CarJS.Maxoil;
                }
                GameManager.pause = false;
            });
            this.closeBtn1.on(Laya.Event.CLICK, this, function () {
                this.fristOil.visible = false;
                this.showFailUI();
            });
            this.open_btn.on(Laya.Event.CLICK, this, this.carDoor);
        }

        BtnLeft() {
            console.log("left");
            if (GameManager.CarJS != null) {
                GameManager.CarJS.left();
            }
        }

        BtnRight() {
            console.log("right");
            if (GameManager.CarJS != null) {
                GameManager.CarJS.right();
            }
        }

        BtnForward() {
            console.log("forward");
            if (GameManager.CarJS != null) {
                GameManager.CarJS.forward();
            }
        }

        BtnBack() {
            console.log("back");
            if (GameManager.CarJS != null) {
                GameManager.CarJS.back();
            }
        }

        update() {
            this.moneyNum.text = GameData.money;

            if (GameManager.CarJS != null) {
                let num = 170 * Math.abs(GameManager.CarJS.speed) / GameManager.CarJS.maxSpeed;
                let speedMask = 1.2625 * Math.abs(GameManager.CarJS.speed * 5);
                if (num > 155) {
                    num = 155;
                    if (GameManager.CarJS.speed >= 0) {
                        GameManager.CarJS.upShift();
                    }
                }
                if (GameManager.Gear != 1 && !GameManager.CarJS.isHuiTan) {
                    this.speed.mask.graphics.clear();
                    this.speed.mask.graphics.drawPie(71, 71, 76, 115, 115 + speedMask, "#ff0000");//前进速度仪表盘显示
                    this.oil.mask.graphics.clear();
                    this.oil.mask.graphics.drawPie(71, 71, 76, 140, 180 + num, "#ff0000");//转速显示
                } else {
                    this.speed.mask.graphics.clear();
                    this.speed.mask.graphics.drawPie(71, 71, 76, 115, 115 + speedMask, "#ff0000");//前进速度仪表盘显示
                    this.oil.mask.graphics.clear();
                    this.oil.mask.graphics.drawPie(71, 71, 76, 140, 180, "#ff0000");//转速显示
                }

                this.speedNum.text = parseInt(Math.abs(GameManager.CarJS.speed) * 5);
            }

            if (this.CameraAni != null) {
                this.normalizedTime = this.CameraAni.getCurrentAnimatorPlayState().normalizedTime;
                if (this.lastnormalizedTime == this.normalizedTime) {
                    if (GameManager.GameScene != null) {
                        if (this.kaichang) {
                            console.log("开场结束");
                            this.kaichang = false;
                            this.createCar(GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("point").getChildByName("born").transform.position);
                            // var _outPos = new Laya.Vector3();
                            // var layaMonkey3D = GameManager.Car.getChildByName("nei").getChildByName("Button");
                            GameManager.pause = false;
                            GameManager.Scene.getChildByName("kaichang").active = false;
                            GameManager.Camera.active = true;
                            // GameManager.CarCamera.viewport.project(layaMonkey3D.transform.position.clone(), GameManager.CarCamera.projectionViewMatrix, _outPos);
                            // this.open_btn.pos(_outPos.x / Laya.stage.clientScaleX, _outPos.y / Laya.stage.clientScaleY);
                            this.kaichangAni.visible = false;
                            this.controlUI.visible = true;
                        }
                    }
                }
                this.lastnormalizedTime = this.normalizedTime;
            }
            this.timeStr.text = GameManager.ChangeMinuteSecondstr(GameManager.timeStr);

            if (this.handle.y > GameManager.GearSize[GameManager.Gear]) {
                this.handle.y -= 2;
            } else if (this.handle.y < GameManager.GearSize[GameManager.Gear]) {
                this.handle.y += 2;
            }
        }

        showSuccessUI() {
            GameManager.pause = true;
            var num = 0;
            var map = GameData.GetUserData("map");
            console.log("num:", num);
            if (map[GameManager.selectLevel] == 1) {
                num = parseInt((parseInt(GameManager.selectLevel) + 1)) * 1000;
            } else {
                num = parseInt((parseInt(GameManager.selectLevel) + 1)) * 100;
            }
            console.log("num:", num);

            this.missionUI.visible = false;
            var map = GameData.GetUserData("map");
            map[GameManager.selectLevel] = 1;
            if (GameManager.timeStr >= 0) {
                // this.missionUI2.visible = true;
                map[GameManager.selectLevel] = 3;
                num = parseInt(num) + parseInt((parseInt(GameManager.selectLevel) + 1)) * 50;
                this.nice.visible = true;
            } else {
                // this.missionUI3.visible = true;
                map[GameManager.selectLevel] = 2;
                this.nice.visible = true;
            }
            GameData.SetData("map", map);
            this.successUI.visible = true;

            console.log("num:", num);
            this.rewardNum.text = num;
            GameData.money = GameData.money + parseInt(this.rewardNum.text);
            GameData.SetData("money", GameData.money);

            if (GameManager.CarJS != null) {
                GameManager.StopSound(GameManager.CarJS.music);
                GameManager.CarJS.music = "";
            }
        }

        showFailUI(id) {
            GameManager.pause = true;
            this.missionUI.visible = false;
            // this.missionUI3.visible = true;
            this.failUI.visible = true;
            Laya.timer.scale = 0.0001;
            if (GameManager.CarJS != null) {
                GameManager.StopSound(GameManager.CarJS.music);
                GameManager.CarJS.music = "";
            }
            switch (id) {
                case 1:
                    this.tip1.visible = true;
                    this.tip2.visible = false;
                    this.tip3.visible = false;
                    break;
                case 2:
                    this.tip1.visible = false;
                    this.tip2.visible = true;
                    this.tip3.visible = false;
                    break;
                case 3:
                    this.tip1.visible = false;
                    this.tip2.visible = false;
                    this.tip3.visible = true;
                    break;
            }
        }

        showFristOilUI() {
            GameManager.pause = true;
            this.fristOil.visible = true;


            if (GameManager.CarJS != null) {
                GameManager.StopSound(GameManager.CarJS.music);
                GameManager.CarJS.music = "";
            }
        }


        onDisable() {
            GameManager.clearData();
            this.destroy();
            GameManager.Scene.destroy();
            GameManager.GameScene = null;
        }
        creatChild(stationID, num) {
            for (var key = 1; key <= num; key++) {
                let id = GameManager.Random(1, 8);
                let name = "child_0" + id;
                let model = Laya.Sprite3D.instantiate(GameManager.CarModel.getChildByName(name), GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("gjz_sh_" + stationID));
                let p = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("gjz_sh_" + stationID).getChildByName("sh_" + stationID + "_pos" + key).transform.position;
                model.transform.position = p;
                model.transform.rotation = GameManager.Scene.getChildByName(GameManager.LevelName[GameManager.selectLevel]).getChildByName("gjz_sh_" + stationID).getChildByName("sh_" + stationID + "_pos" + key).transform.rotation;
                var child = model.addComponent(Child);
                let finishPos = "sh_" + stationID + "_pos1";
                let childPos = "sh_" + stationID + "_pos" + key;
                child.Init(stationID, key);
                GameManager.childList.push(child);
            }
        }
        carDoor() {
            if (Math.abs(GameManager.CarJS.speed) > 1 || this.kaiguanFlag) {
                return;
            }
            if (!this.doorFlag) {
                Laya.timer.once(2 * 1000, this, function () {
                    this.doorFlag = true;
                });
                this.open_btn.skin = "gameScene/closedoor_img.png";
                // GameManager.CarJS.carAnimator.crossFade("open", 0.2);
            } else {
            }
            this.kaiguanFlag = true;
            Laya.timer.clear(this, this.resetFlag);
            this.resetFlag();
        }
        resetFlag() {
            Laya.timer.once(3 * 1000, this, function () {
                this.kaiguanFlag = false;
            });
        }
    }

    class JSBridge {
        static InitJSBridge() {
            //需要完整的类路径，注意与iOS的不同
            JSBridge.bridge = PlatformClass.createClass("demo.JSBridge");//创建脚步代理
            if (window.conch && window.conch.setOnBackPressedFunction) {
                window.conch.setOnBackPressedFunction(() => {
                });
            }
        }
        static showTips() {
            JSBridge.bridge.call("showTips");
        }
        static getLogo() {
            JSBridge.logoUrl = JSBridge.bridge.call("getLogo");
            console.log("JSBridge.logoUrl   " + JSBridge.logoUrl);

        }
        static initLabel() {
            JSBridge.bridge.call("initLabel");
        }
        static getJPGUrl_loading(index) {
            JSBridge.JPGUrl_loading = JSBridge.bridge.call("getJPGUrl_loading", index);
            console.log("JPGUrl_loading地址：" + JSBridge.JPGUrl_loading);
            return JSBridge.JPGUrl_loading;
        }

        static getJPGUrl_main(index) {
            JSBridge.logoUrl_main = JSBridge.bridge.call("getJPGUrl_main", index);
            console.log("logoUrl_main地址：" + JSBridge.logoUrl_main);
            return JSBridge.logoUrl_main;
        }

        static getJPGNum_loading() {
            return JSBridge.bridge.call("getJPGNum_loading");
        }

        static getJPGNum_main() {
            return JSBridge.bridge.call("getJPGNum_main");
        }

        static random(min, max) {
            return Math.floor(Math.random() * (max + 1 - min)) + min;
        }
    }
    JSBridge.bridge = null;
    JSBridge.logoUrl = null;
    JSBridge.JPGUrl_loading = null;
    JSBridge.logoUrl_main = null;

    class LabelUtils {
        static getBaseUrl() {
            if (LabelUtils._ISDEBUG) {
                return this._DEBUG_BASE_URL;
            }
            return this._RELEASE_BASE_URL;
        }

        /**
         * 在没有获取到标签配置之前统一返回false
         * 在没有获取到是否是特殊省份时统一返回false
         *
         *
         * @param key
         * @returns {boolean}
         */
        static getLabel(key) {
            console.log("即将获取标签:::" + key);
            if (!key || !LabelUtils.initLabelSuccess || !LabelUtils.initIsSpecial) {
                return false;
            }
            console.log("正在获取标签>>>>:::" + key);

            if (LabelUtils.isSpecial) {
                if (LabelUtils.labels.special.length > 0) {
                    for (let i = 0, t = LabelUtils.labels.special.length; i < t; i++) {
                        let val = LabelUtils.labels.special[i];
                        // console.log(val.switchname + ">>>" + val.switchvalue + ">>>>key::" + key);
                        if (val.switchname == key) {
                            let b = val.switchvalue == 1;
                            console.log(key + "::" + b);
                            return b;
                        }
                    }
                    return false;


                } else {
                    return false;
                }
            } else {
                if (LabelUtils.labels.common.length > 0) {
                    for (let i = 0, t = LabelUtils.labels.common.length; i < t; i++) {
                        let val = LabelUtils.labels.common[i];
                        //   console.log(val.switchname + ">>>" + val.switchvalue + ">>>>key::" + key);

                        if (val.switchname == key) {
                            let b = val.switchvalue == 1;
                            console.log(key + "::" + b);
                            return b;
                        }
                    }
                    return false;
                } else {
                    return false;
                }
            }


        }
        static getValue(key, defaultValue) {


            if (LabelUtils.labels && LabelUtils.labels.hasOwnProperty("selfswitch")) {

                for (let i = 0; i < LabelUtils.labels.selfswitch.length; i++) {
                    let val = LabelUtils.labels.selfswitch[i];


                    if (val.switchname == key) {

                        let regFloat = /(-?\d+)(\.\d+)?/;//浮点数


                        let isFloatStr = regFloat.test(val.switchvalue);
                        if (isFloatStr) {

                            console.log("是个浮点");
                            let number = parseFloat(val.switchvalue);

                            return isNaN(number) ? val.switchvalue : number;


                        }

                        let regInt = /-?\d+/;//整数


                        let isIntStr = regInt.test(val.switchvalue);
                        if (isIntStr) {
                            console.log("是个整数");

                            let number1 = parseInt(val.switchvalue);
                            return isNaN(number1) ? val.switchvalue : number1;


                        }
                        return val.switchvalue;
                    }


                }
                return defaultValue;

            } else {
                return defaultValue;
            }
        }
        /**
         * 初始化步骤：
         *  1、异步执行ip定位，获取服务器标签配置，获取服务器上省份列表
         *  2、之后会判断当前省份是否是在屏蔽列表中，判断完成之后真正初始化完成
         *  3、
         * @param labelName
         */
        static initLabel(labelName) {
            console.log("initLabel:" + labelName);

            if (!!labelName && labelName.length > 0) {
                LabelUtils._labelName = labelName;
            }
            console.log("initLabel:  start");

            this._getMyLocation();
            this._fetchLabel();
            this._fetchLocationList();

        }
        /**
         * 重新刷新标签配置  从服务器重新获取标签配置
         */
        static refreshLabelConfig() {
            if (this.canRefresh) {
                this._fetchLabel();

            }
        }

        /**
         * 初始化是否是特殊省份
         * @private
         */
        static _initIsSpecial() {

            LabelUtils.isSpecial = false;
            let tmpId = 0;
            if (LabelUtils.location && LabelUtils.initLabelSuccess && LabelUtils.locationList) {
                for (let i = 0; i < LabelUtils.locationList.length; i++) {
                    if (LabelUtils.location == LabelUtils.locationList[i].name) {
                        tmpId = LabelUtils.locationList[i].id;
                        // console.log(this.location + "...." + this.locationList[i].name)
                        break;
                    }
                }
                if (LabelUtils.labels.blocked) {
                    let split = LabelUtils.labels.blocked.split(",");
                    if (split) {
                        for (let i = 0; i < split.length; i++) {
                            if (tmpId == split[i]) {
                                LabelUtils.isSpecial = true;
                                break
                            }

                        }
                    }

                }
            }
            LabelUtils.initIsSpecial = true;
            console.log("特殊省份isSpecial:" + LabelUtils.isSpecial);
        }
        static _fetchLocationList() {

            console.log("get Province List");
            LabelUtils._httpGets(LabelUtils.getBaseUrl() + "/config.json", false, function (res) {
                //console.log("_fetchLocationList Resp:>>" + res)
                LabelUtils._retryTimeLocationList++;

                if (res) {
                    let parse = JSON.parse(res);
                    if (parse.code == 1000) {
                        LabelUtils.locationList = parse.data;
                        console.log("_fetchLocationList Success");
                        LabelUtils._initIsSpecial();
                    } else {
                        Laya.timer.frameOnce(60 * LabelUtils._retryTimeLocationList, this, function () {
                            LabelUtils._fetchLocationList();
                        });
                    }
                } else {
                    Laya.timer.frameOnce(60 * LabelUtils._retryTimeLocationList, this, function () {
                        LabelUtils._fetchLocationList();
                    });
                }

            });

        }
        static _fetchLabel() {
            console.log("start   _fetchLabel");
            LabelUtils._retryTime++;

            LabelUtils._httpGets(this.getBaseUrl() + "/" + this._labelName + ".json?t=" + new Date().getTime(), false, function (res) {

                //console.log("_fetchLabel Resp:>>" + res);
                if (res != -1) {

                    let parse = JSON.parse(res);
                    if (!!parse && parse.code == 1000) {
                        LabelUtils.labels = parse.data;
                        LabelUtils.initLabelSuccess = true;
                        console.log("initLabel Success");
                        LabelUtils._initIsSpecial();
                        LabelUtils.canRefresh = true;
                    } else {
                        Laya.timer.frameOnce(60 * LabelUtils._retryTime, this, function () {
                            LabelUtils._fetchLabel();
                        });

                    }


                } else {
                    Laya.timer.frameOnce(60, this, function () {
                        LabelUtils._fetchLabel();
                    });
                }

            });

        }
        static _getMyLocation() {
            console.log("label:getLocation");

            this._httpGetsLocation("https://pv.sohu.com/cityjson?ie=utf-8", function (res) {
                //  console.log(res + ">>>>>>>>>>>");

                if (res != -1) {
                    let s2 = res.toString();
                    let s3 = s2.substring(s2.indexOf("{"), s2.lastIndexOf("}") + 1);
                    // console.log(s3)
                    let parse = JSON.parse(s3);
                    if (parse && parse.cname) {
                        let s = parse.cname;
                        // console.log(s)
                        if (s.indexOf("省") != -1) {
                            s = s.substring(0, s.indexOf("省"));
                        } else if (s.indexOf("市") != -1) {
                            s = s.substring(0, s.indexOf("市"));
                        } else {
                            s = s.substring(0, 2);
                        }
                        console.log(s);
                        LabelUtils.location = s;
                        LabelUtils._initIsSpecial();
                    } else {
                        Laya.timer.frameOnce(120, this, function () {
                            LabelUtils._getMyLocation();
                        });
                    }


                } else {

                    Laya.timer.frameOnce(120, this, function () {
                        LabelUtils._getMyLocation();
                    });
                }


            });
            console.log("label:getLocation  End");


        }

        static _httpGetsLocation(url, callback) {
            console.log("label:_httpGetsLocation 1111 ");
            // var xhr = new Laya.HttpRequest();
            // xhr.http.timeout = 10000;//设置超时时间；
            // xhr.once(Laya.Event.COMPLETE,this,function(e)
            // {
            //     var respone = e ;
            //     console.log("服务器返回完成："+respone);
            //     callback(respone);
            // });
            // xhr.once(Laya.Event.ERROR,this,function(data)
            // {
            //     console.log("服务器返回错误："+data);
            //     callback(-1);
            // });
            // xhr.on(Laya.Event.PROGRESS,this,function(data)
            // {
            //     console.log("服务器返回："+data);
            // });
            // var h = ["Content-Type", "application/x-www-form-urlencoded"] ;
            // xhr.send(url,"","get","text");
            LabelUtils._httpGets(url, "", callback);
        }

        static _httpGets(url, needHeader, callback) {
            console.log("label:HttpGets  ");

            if (window["wx"]) {
                var xhr = new Laya.HttpRequest();
                xhr.http.timeout = 10000;//设置超时时间；
                xhr.once(Laya.Event.COMPLETE, this, function (e) {
                    var respone = e;
                    console.log("服务器返回完成：" + respone);
                    callback(respone);
                });
                xhr.once(Laya.Event.ERROR, this, function (data) {
                    console.log("服务器返回错误：" + data);
                    callback(-1);
                });
                xhr.on(Laya.Event.PROGRESS, this, function (data) {
                    console.log("服务器返回：" + data);
                });
                xhr.send(url, "", "get", "text");
            } else {
                var xhr = new XMLHttpRequest();
                xhr.addEventListener("load", function () {
                    if (xhr.responseText) {
                        callback(xhr.responseText);
                    } else {
                        callback(-1);
                    }
                    console.log("服务器返回完成：" + xhr.responseText);
                });
                xhr.open("GET", url);
                xhr.send();
            }
        }

    }
    LabelUtils._ISDEBUG = false;
    LabelUtils._RELEASE_BASE_URL = "https://qygres.17666.mobi/label";
    LabelUtils._DEBUG_BASE_URL = "http://192.168.0.242:19800/label";
    LabelUtils._labelName = "";
    LabelUtils.location = "";
    LabelUtils.labels = null;
    LabelUtils._retryTime = 0;
    LabelUtils.isSpecial = false;
    LabelUtils._retryTimeLocationList = 0;
    LabelUtils.locationList = [];
    LabelUtils.initLabelSuccess = false;
    LabelUtils.initIsSpecial = false;

    class SDK_apk {
        static Init(labelName, key1, key2, key3) {//labelName：标签名   key1：套路时间   key2：间隔时间   key3：插屏开关
            LabelUtils.initLabel(labelName);
            setTimeout(() => {
                if (LabelUtils.getLabel(key3)) {
                    var tlsj = LabelUtils.getValue(key1, 60);
                    var sj = LabelUtils.getValue(key2, 30);
                    console.log("套路时间为:" + tlsj + "        间隔时间为:" + sj);
                    setTimeout(() => {
                        setInterval(() => {
                            SDK_apk.showNative();
                        }, sj * 1000);
                    }, tlsj * 1000);
                }
            }, 1000);
        }
        static showNative() {
            if (window.android) {
                window.android.showNative();
            }
        }
        static showNativeIcon() {
            if (window.android && LabelUtils.getLabel("icon")) {
                window.android.showIconAD(1);
            }
        }
        static showBanner() {
            // if (window.android) {
            //     window.android.showBanner(2);
            // }
        }
        static getLogoUrl() {
            if (window.android) {
                SDK_apk.logoUrl = window.android.getLogoUrl();
                console.log("logo地址：" + SDK_apk.logoUrl);
            }
        }
        static getJPGUrl_loading(index) {
            if (window.android) {
                SDK_apk.JPGUrl_loading = window.android.getJPGUrl_loading(index);
                console.log("JPGUrl_loading地址：" + SDK_apk.JPGUrl_loading);
                return SDK_apk.JPGUrl_loading;
            }
        }

        static getJPGUrl_main(index) {
            if (window.android) {
                SDK_apk.logoUrl_main = window.android.getJPGUrl_main(index);
                console.log("logoUrl_main地址：" + SDK_apk.logoUrl_main);
                return SDK_apk.logoUrl_main;
            }
        }

        static getJPGNum_loading() {
            if (window.android) {
                return window.android.getJPGNum_loading();
            }
        }

        static getJPGNum_main() {
            if (window.android) {
                return window.android.getJPGNum_main();
            }
        }
        static random(min, max) {
            return Math.round(Math.random() * (max - min) + min);
        }
    }
    SDK_apk.logoUrl = null;
    SDK_apk.JPGUrl_loading = null;
    SDK_apk.logoUrl_main = null;

    class loading extends Laya.Scene {

        constructor() {
            super();
        }

        onEnable() {
            this.logo.skin = "";
            if (window.android) {
                this.logo.skin = SDK_apk.logoUrl;
                var jpgIndex = SDK_apk.random(0, SDK_apk.getJPGNum_loading() - 1);
                console.log("jpgIndex:" + jpgIndex);
                var JPGbg = new Laya.Image(SDK_apk.getJPGUrl_loading(jpgIndex));
                JPGbg.zOrder = -1;
                JPGbg.centerX = 0;
                JPGbg.centerY = 0;
                this.addChild(JPGbg);
            }
            // if (Laya.Browser.onAndroid) {
            //     this.logo.skin = JSBridge.logoUrl;
            //     var jpgIndex = JSBridge.random(0, JSBridge.getJPGNum_loading() - 1);
            //     console.log("jpgIndex:" + jpgIndex);
            //     var JPGbg = new Laya.Image(JSBridge.getJPGUrl_loading(jpgIndex));
            //     JPGbg.zOrder = -1;
            //     JPGbg.centerX = 0;
            //     JPGbg.centerY = 0;
            //     this.addChild(JPGbg);
            // }
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.loadValue = 1;
            this.updateLoadValue = 0;

            Laya.timer.loop(1, this, this.update);

            // this.resource = [
            //     "res/unity_res/LayaScene_map/Conventional/map.ls",
            //     "res/unity_res/LayaScene_che/Conventional/che.lh",
            // ];

            // Laya.loader.create(this.resource, Laya.Handler.create(this, this.onPreLoadFinish),
            //     Laya.Handler.create(this, function (value) {
            //         this.loadValue = value;
            //         console.log("加载进度：", this.loadValue);
            //     })
            // );
        }

        // onPreLoadFinish() {
        //     GameManager.ResScene = Laya.Loader.getRes("res/unity_res/LayaScene_map/Conventional/map.ls");
        //     GameManager.CarModel = Laya.Loader.getRes("res/unity_res/LayaScene_che/Conventional/che.lh");
        // }

        update() {
            this.updateLoadValue += 0.01;
            if (this.updateLoadValue > this.loadValue) {
                this.updateLoadValue = this.loadValue;
            }

            this.loadBar.value = this.updateLoadValue;

            if (this.loadBar.value >= 1) {
                Laya.timer.clear(this, this.update);
                GameData.InitData(function () {
                    Laya.Scene.open("mainScene.scene");
                    // JSBridge.initLabel();
                    // Laya.stage.on(Laya.Event.BLUR, this, () => {
                    //     Laya.SoundManager.stopAll();
                    // });
                    // Laya.stage.on(Laya.Event.FOCUS, this, () => {
                    //     GameManager.PlayMusic("bgm");
                    // });
                });
            }
        }

        onDisable() {

        }
    }

    class mainScene extends Laya.Scene {

        constructor() {
            super();
        }

        onEnable() {
            this.logo.skin = "";
            if (window.android) {
                this.logo.skin = SDK_apk.logoUrl;
                var jpgIndex = SDK_apk.random(0, SDK_apk.getJPGNum_main() - 1);
                console.log("jpgIndex:" + jpgIndex);
                var JPGbg = new Laya.Image(SDK_apk.getJPGUrl_main(jpgIndex));
                JPGbg.zOrder = -1;
                JPGbg.centerX = 0;
                JPGbg.centerY = 0;
                this.addChild(JPGbg);
            }
            // if (Laya.Browser.onAndroid) {
            //     this.logo.skin = JSBridge.logoUrl;
            //     var jpgIndex = JSBridge.random(0, JSBridge.getJPGNum_main() - 1);
            //     console.log("jpgIndex:" + jpgIndex);
            //     var JPGbg = new Laya.Image(JSBridge.getJPGUrl_main(jpgIndex));
            //     JPGbg.zOrder = -1;
            //     JPGbg.centerX = 0;
            //     JPGbg.centerY = 0;
            //     this.addChild(JPGbg);
            // }
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            Laya.timer.scale = 1;
            GameManager.PlayMusic("bgm");

            this.startBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mapScene.scene", true, false);
            });
            this.garageBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("cheScene.scene");
            });
            this.settingBtn.on(Laya.Event.CLICK, this, this.onpenSettintUI);
            this.settingCloseBtn.on(Laya.Event.CLICK, this, this.closeSettintUI);

            this.openMusicBtn.on(Laya.Event.CLICK, this, function () {
                GameManager.OpenSound();
            });

            this.closeMusicBtn.on(Laya.Event.CLICK, this, function () {
                GameManager.CloseSound();
            });

            this.ageBtn.on(Laya.Event.CLICK, this, function () {
                // JSBridge.showTips();
                if (window.android) {
                    window.android.showNotice();
                }
            });

            this.moneyNum.text = GameData.money;
        }

        onpenSettintUI() {
            this.settingUI.visible = true;
        }

        closeSettintUI() {
            this.settingUI.visible = false;
        }


        onDisable() {

        }
    }

    class mapScene extends Laya.Scene {

        constructor() {
            super();
        }

        onEnable() {
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;

            this.loadValue = 1;
            this.updateLoadValue = 0;
            Laya.timer.scale = 1;
            this.resource = [
                // "res/unity_res/LayaScene_map/Conventional/map.ls",
                // "res/unity_res/LayaScene_che/Conventional/che.lh",
                "res/unity_res/LayaScene_map3/Conventional/map3.ls",
                "res/unity_res/LayaScene_che3/Conventional/che3.lh",
            ];

            Laya.loader.create(this.resource, Laya.Handler.create(this, this.onPreLoadFinish),
                Laya.Handler.create(this, function (value) {
                    this.loadValue = value;
                })
            );

            this.startBtn.on(Laya.Event.CLICK, this, function () {
                this.loading.visible = true;
                Laya.timer.loop(1, this, this.update);
            });
            this.backBtn.on(Laya.Event.CLICK, this, function () {
                Laya.Scene.open("mainScene.scene");
            });

            this.selectBtns = [];
            this.selectBtns.push(this.shanghai1);
            this.selectBtns.push(this.nanjing2);
            this.selectBtns.push(this.guangzhou3);
            this.selectBtns.push(this.qingdao4);
            this.selectBtns.push(this.beijing5);

            var map = GameData.GetUserData("map");
            for (var key in this.selectBtns) {
                this.selectBtns[key].on(Laya.Event.CLICK, this, this.selectMap, [key]);
                if (map[key] == 0) {
                    this.selectBtns[key].getChildByName("lock").visible = true;
                } else if (map[key] == 1) {
                    this.selectBtns[key].getChildByName("unlock").visible = true;
                } else if (map[key] == 2) {
                    this.selectBtns[key].getChildByName("pass").visible = true;
                } else if (map[key] == 3) {
                    this.selectBtns[key].getChildByName("nice").visible = true;
                    this.selectBtns[key].getChildByName("pass").visible = true;
                }
            }
        }

        onOpened(type) {
            if (type) {
                this.selectMap(GameManager.selectLevel);
                this.loading.visible = true;
                Laya.timer.loop(1, this, this.update);
            } else {
                this.selectMap(0);
            }
        }

        onPreLoadFinish() {
            GameManager.ResScene = Laya.Loader.getRes("res/unity_res/LayaScene_map3/Conventional/map3.ls");
            GameManager.CarModel = Laya.Loader.getRes("res/unity_res/LayaScene_che3/Conventional/che3.lh");
        }

        selectMap(id) {
            this.selectBtns[GameManager.selectLevel].getChildByName("isSelect").visible = false;
            GameManager.selectLevel = id;
            this.selectBtns[GameManager.selectLevel].getChildByName("isSelect").visible = true;
            var pos = parseInt(id) + 1;
            this.title.text = GameData.JSONMap[pos].title;
            this.introduce.text = GameData.JSONMap[pos]["introduce"];
        }

        update() {
            this.updateLoadValue += 0.01;
            if (this.updateLoadValue > this.loadValue) {
                this.updateLoadValue = this.loadValue;
            }

            this.loadBar.value = this.updateLoadValue;

            if (this.loadBar.value >= 1) {
                Laya.timer.clear(this, this.update);
                Laya.Scene.open("gameScene.scene");
            }
        }

        onDisable() {
        }
    }

    /**This class is automatically generated by LayaAirIDE, please do not make any modifications. */

    class GameConfig {
        static init() {
            //注册Script或者Runtime引用
            let reg = Laya.ClassUtils.regClass;
    		reg("script/cheScene.js",cheScene);
    		reg("script/gameScene.js",gameScene);
    		reg("script/loading.js",loading);
    		reg("script/mainScene.js",mainScene);
    		reg("script/mapScene.js",mapScene);
        }
    }
    GameConfig.width = 1280;
    GameConfig.height = 720;
    GameConfig.scaleMode ="fixedheight";
    GameConfig.screenMode = "horizontal";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "loading.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;

    GameConfig.init();

    class Main {
    	constructor() {
    		//根据IDE设置初始化引擎		
    		if (window["Laya3D"])
    			Laya3D.init(GameConfig.width, GameConfig.height, null, Laya.Handler.create(this, this.initMain));
    		else {
    			Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
    			this.initMain();
    		}

    	}
    	initMain() {
    		Laya["Physics"] && Laya["Physics"].enable();
    		Laya["DebugPanel"] && Laya["DebugPanel"].enable();
    		Laya.stage.scaleMode = GameConfig.scaleMode;
    		Laya.stage.screenMode = GameConfig.screenMode;
    		Laya.stage.alignV = GameConfig.alignV;
    		Laya.stage.alignH = GameConfig.alignH;
    		//兼容微信不支持加载scene后缀场景
    		Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;

    		//打开调试面板（通过IDE设置调试模式，或者url地址增加debug=true参数，均可打开调试面板）
    		if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true") Laya.enableDebugPanel();
    		if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"]) Laya["PhysicsDebugDraw"].enable();
    		if (GameConfig.stat) Laya.Stat.show();
    		Laya.alertGlobalError(true);
    		// JSBridge.InitJSBridge();
    		// JSBridge.getLogo();
    		SDK_apk.getLogoUrl();

    		//激活资源版本控制，version.json由IDE发布功能自动生成，如果没有也不影响后续流程
    		Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
    	}

    	onVersionLoaded() {
    		//激活大小图映射，加载小图的时候，如果发现小图在大图合集里面，则优先加载大图合集，而不是小图
    		Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
    	}

    	onConfigLoaded() {
    		//加载IDE指定的场景
    		GameConfig.startScene && Laya.Scene.open(GameConfig.startScene);
    	}
    }
    //激活启动类
    new Main();

}());
